package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.lzmispt.core.entity.dto.authorize.UserInfoDTO;
import com.lzmispt.core.entity.dto.querymodel.FilterFieldDTO;
import com.lzmispt.core.entity.dto.querymodel.FilterGroupModelDTO;
import com.lzmispt.core.entity.dto.querymodel.FilterModelDTO;
import com.lzmispt.core.entity.dto.querymodel.QueryModelDTO;
import com.lzmispt.data.center.entity.dto.log.CommonLogDTO;
import com.lzmispt.data.center.entity.dto.resdata.GetEntityBaseInfoDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.EntityDefaultPropertyDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.SaveMetadataItemElementDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.SaveMetadataValueEntityDTO;
import com.lzmispt.data.center.entity.dto.standard.tag.TagDTO;
import com.lzmispt.data.center.entity.dto.standard.tag.UpdateTagMsg;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataDirectoryVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.GetEntityBaseInfoVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataClasssVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityWithElementVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataItemVO;
import com.lzmispt.data.center.entity.vo.standard.version.VersionContentVO;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.dao.metadata.IMetadataDao;
import com.lzmispt.data.resource.dao.resources.IResourceFileInfoTableDao;
import com.lzmispt.data.resource.dao.resources.IResourcesDao;
import com.lzmispt.data.resource.entity.dto.metadata.MetadataDirectoryDTO;
import com.lzmispt.data.resource.entity.dto.metadata.SaveMetadataEntityDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.SaveEntityBaseInfoDTO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataDirectoryPO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityPO;
import com.lzmispt.data.resource.entity.po.resources.ResDirectoryPO;
import com.lzmispt.data.resource.entity.po.resources.ResFileInfoTablePO;
import com.lzmispt.data.resource.entity.vo.metadata.DirectoryTreeContainEntityIdVO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.metadata.IDataResource;
import com.lzmispt.data.resource.service.metadata.IResAndDataDirEntity;
import com.lzmispt.data.resource.service.metadata.IResAndDataResource;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.dcbase.log.CommonLogHelper;
import com.lzmispt.dcbase.util.HeaderInterceptor;
import com.lzmispt.dcbase.util.TokenUtil;
import com.lzmispt.framework.entity.entity.ResultEntity;
import com.lzmispt.framework.exception.ExceptionUtil;
import com.lzmispt.framework.fconst.FrameConst;
import com.lzmispt.framework.utils.RabbitMQUtil;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

@RefreshScope
@Service
public class ResAndDataDirEntityImpl implements IResAndDataDirEntity {
  private static final List<String> INNER_ELEMENT_NAMES = Arrays.asList(new String[] { "lzdc_sys_create_time", "lzdc_sys_update_time", "lzdc_sys_data_count" });
  
  @Autowired
  private DataStandardClient standardClient;
  
  @Autowired
  IResAndDataResource iResAndDataResource;
  
  private static String FILE_SUFFIX = "_file";
  
  public static List<String> STANDARD_ENTITY_FIX_FIELDS = Arrays.asList(new String[] { "lzdc_sys_ref_entity_id", "lzdc_sys_ref_entity_version", "lzdc_sys_ref_biz_entity_id", "lzdc_sys_version" });
  
  public MetadataDirectoryPO selectOne(int id, Integer isResources, String platCode) {
    return null;
  }
  
  public MetadataDirectoryPO selectTwo(int id, Integer isResources, String platCode) {
    return null;
  }
  
  public void insertMetadataDirectory(MetadataDirectoryPO metadataDirectory, Integer isResources, String platCode) {}
  
  public Integer updateMetadataDirectory(MetadataDirectoryPO metadataDirectory, Integer isResources, String platCode) {
    return null;
  }
  
  public void updateChildMetadataDirectoryLevel(Long directoryId, Integer directoryLevel, Integer isResources, String platCode) {}
  
  public MetadataDirectoryPO selectDirectoryByDirectoryId(Long directoryId, Integer isResources, String platCode) {
    MetadataDirectoryPO parentMetadatadirectory = null;
    if (DCConst.DataResourceCategory.RES.equals(isResources)) {
      ResDirectoryPO resDirectoryPO = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).selectDirectoryByDirectoryId(directoryId);
      if (resDirectoryPO != null) {
        parentMetadatadirectory = new MetadataDirectoryPO();
        BeanUtils.copyProperties(resDirectoryPO, parentMetadatadirectory);
      } 
    } else {
      parentMetadatadirectory = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).selectDirectoryByDirectoryId(directoryId);
    } 
    return parentMetadatadirectory;
  }
  
  public MetadataDirectoryVO getDirectoryByDirectoryId(Long directoryId, Integer isResources, String platCode) {
    MetadataDirectoryPO metadataDirectoryPO = selectDirectoryByDirectoryId(directoryId, isResources, platCode);
    MetadataDirectoryVO metadataDirectoryVO = new MetadataDirectoryVO();
    if (!Objects.isNull(metadataDirectoryPO))
      BeanUtils.copyProperties(metadataDirectoryPO, metadataDirectoryVO); 
    return metadataDirectoryVO;
  }
  
  public List<MetadataDirectoryPO> selectDirectoryListByDirectoryId(Long directoryId, Integer dataCategory, Integer directoryType, List<Long> targetDirectoryIdList, Integer isResources, String platCode) {
    List<MetadataDirectoryPO> poList = new ArrayList<>();
    if (DCConst.DataResourceCategory.RES.equals(isResources)) {
      List<ResDirectoryPO> resDirectoryPOList = ((IResourcesDao)ServiceUtil.getResourcesDao(platCode, IResourcesDao.class)).selectDirectoryListByDirectoryId(directoryId, directoryType, targetDirectoryIdList);
      for (ResDirectoryPO resDirectoryPO : resDirectoryPOList) {
        MetadataDirectoryPO metadataDirectoryPO = new MetadataDirectoryPO();
        BeanUtils.copyProperties(resDirectoryPO, metadataDirectoryPO);
        poList.add(metadataDirectoryPO);
      } 
    } else {
      poList = ((IMetadataDao)ServiceUtil.getMetadataDao(platCode, IMetadataDao.class)).selectDirectoryListByDirectoryId(directoryId, directoryType, targetDirectoryIdList);
    } 
    return poList;
  }
  
  public List<DirectoryTreeContainEntityIdVO> selectDirectoryTreeContainEntityId(Long directoryId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectDirectoryTreeContainMasterTable(Long directoryId, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectDirectoryTreeContainMasterTableByName(String directoryName, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectDirectoryContainMasterTableByParentId(Long directoryId, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public void updateParentDirectoryIdNull(Long directoryId, Integer isResources, String platCode) {}
  
  public List<DirectoryTreeContainEntityIdVO> selectRecursionDirectoryContainEntityId(Long directoryId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<Long> selectParentDirectoryIdList(Long directoryId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<DirectoryTreeContainEntityIdVO> selectRecursionDirectoryContainEntityIdByName(String directoryName, Integer isResources, String platCode) {
    return null;
  }
  
  public MetadataDirectoryPO selectMaxDirectoryOrderByDirectoryId(Long directoryId, Integer dataCategory, Integer isResources, String platCode) {
    return null;
  }
  
  public int checkExistsDirectory(Map<String, Object> param, Integer isResources, String platCode) {
    return 0;
  }
  
  public List<MetadataDirectoryPO> checkExistsDirectoryCode(Map<String, Object> param, Integer isResources, String platCode) {
    return null;
  }
  
  public Integer deleteDirectoryByDirectoryId(Long directoryId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectAllDirectoryByDirectoryId(Long directoryId, Integer dataCategory, Integer directoryType, String directoryName, List<Long> targetDirectoryIdList, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectSpaceDataAllDirectoryByDirectoryId(Long directoryId, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectAllDirectoryByDirectoryIds(List<Long> ids, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectAllDirectoryByName(String directoryName, Integer dataCategory, Integer directoryType, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectAllDirectoryById(String directoryId, Integer dataCategory, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> selectAllDirectoryByDirectoryName(String directoryName, Integer isResources, String platCode) {
    return null;
  }
  
  public int selectTotalDirectoryByDataSourceId(Long dataSourceId, Integer directoryType, Integer isResources, String platCode) {
    return 0;
  }
  
  public List<MetadataDirectoryPO> selectDirectoryListByFileTableId(Long fileTableId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataDirectoryPO> getDirectoriesByEntityIds(List<Long> entityIds, Integer isResources, String platCode) {
    return null;
  }
  
  public void updateMetadataEntity(MetadataEntityPO metadataEntity, Integer isResources, String platCode) {}
  
  public void updateChildMetadataEntity(Long parentEntityId, String dataSchemaName, Integer isResources, String platCode) {}
  
  public void insertMetadataEntity(MetadataEntityPO metadataEntity, Integer isResources, String platCode) {}
  
  public List<MetadataEntityPO> selectMetadataEntityByDirectoryId(Long direcotryId, Integer isResources, String platCode) {
    return null;
  }
  
  public MetadataEntityPO selectIsMasterMetadataEntityByDirectoryId(Long direcotryId, Integer isResources, String platCode) {
    return null;
  }
  
  public Integer deleteMetadataEntityByEntityId(Long entityId, Integer isResources, String platCode) {
    return null;
  }
  
  public List<MetadataEntityPO> getAllMetadataEntities(Integer dataCategory, Integer isResources, String platCode) {
    return null;
  }
  
  public int selectMetadataEntityByDataSourceIdAndTableName(Long dataSourceId, String entityTableName, Long entityId, Integer isResources, String platCode) {
    return 0;
  }
  
  public List<MetadataEntityPO> selectMetadataEntitiesByParentId(Long parentEntityId, Integer isResources, String platCode) {
    return null;
  }
  
  public int selectTotalMetadataEntityByDataSourceId(Long dataSourceId, Integer isResources, String platCode) {
    return 0;
  }
  
  public List<MetadataEntityPO> selectEntitysByDataSourceIdAndTableName(Long dataSourceId, String entityTableName, Integer isResources, String platCode) {
    return null;
  }
  
  public ResultEntity<GetEntityBaseInfoVO> getEntityBaseInfo(GetEntityBaseInfoDTO getEntityBaseInfoDTO, String platCode, String tokenId, Integer dataCategory) {
    String metadataCategory = DCConst.MetadataCategory.DATA_ENTITY;
    if (dataCategory.equals(DCConst.DataResourceCategory.DATA)) {
      metadataCategory = DCConst.MetadataCategory.DATA_ENTITY;
    } else if (dataCategory.equals(DCConst.DataResourceCategory.RES)) {
      metadataCategory = DCConst.MetadataCategory.RES_ENTITY;
    } 
    ResultEntity<List<MetadataClasssVO>> result = this.standardClient.getMetadataClassInfo(metadataCategory, platCode, tokenId);
    List<MetadataClasssVO> metadataClasssVOS = (List<MetadataClasssVO>)result.getObj();
    MetadataEntityWithElementVO metadataEntityWithElementVO = null;
    if (getEntityBaseInfoDTO.getEntityId() != null) {
      if (DCConst.TRUE.equals(getEntityBaseInfoDTO.getIsShowVersionChange())) {
        metadataEntityWithElementVO = (MetadataEntityWithElementVO)this.standardClient.getEntityWithVersionChangeByEntityId(getEntityBaseInfoDTO.getEntityId(), dataCategory, platCode, tokenId).getObj();
      } else {
        metadataEntityWithElementVO = (MetadataEntityWithElementVO)this.standardClient.getEntityWithElementByEntityId(getEntityBaseInfoDTO.getEntityId(), dataCategory, platCode, tokenId).getObj();
      } 
    } else {
      metadataEntityWithElementVO = (MetadataEntityWithElementVO)this.standardClient.getEntityWithElementByDirectoryId(getEntityBaseInfoDTO.getDirectoryId(), dataCategory, platCode, tokenId).getObj();
    } 
    if (metadataEntityWithElementVO == null)
      return ResultEntity.errorMessage(Integer.valueOf(-1), "获取实体基本信息失败"); 
    List<MetadataItemVO> metadataItemList = metadataEntityWithElementVO.getMetadata();
    if (!CollectionUtils.isEmpty(metadataItemList))
      metadataItemList = (List<MetadataItemVO>)metadataItemList.stream().filter(item -> (DCConst.TRUE.equals(item.getIsShow()) || (DCConst.FALSE.equals(item.getIsShow()) && DCConst.FALSE.equals(item.getIsSystem())))).collect(Collectors.toList()); 
    GetEntityBaseInfoVO getEntityBaseInfoVO = new GetEntityBaseInfoVO();
    if (!CollectionUtils.isEmpty(metadataItemList)) {
      Map<Long, GetEntityBaseInfoVO.MetadataClassInfoVO> metadataClassInfoMap = new HashMap<>();
      MetadataClasssVO baseInfo = metadataClasssVOS.stream().filter(m -> m.getCode().equals("lzdc_sys_base_info")).findFirst().orElse(null);
      List<MetadataItemVO> sysThreeField = new ArrayList<>();
      for (MetadataItemVO metadataItemVO : metadataItemList) {
        if (INNER_ELEMENT_NAMES.contains(metadataItemVO.getElementName())) {
          metadataItemVO.setElementClass(baseInfo.getId());
          sysThreeField.add(metadataItemVO);
          continue;
        } 
        GetEntityBaseInfoVO.MetadataClassInfoVO metadataClassInfoVO = metadataClassInfoMap.get(metadataItemVO.getElementClass());
        if (metadataClassInfoVO == null) {
          metadataClassInfoVO = new GetEntityBaseInfoVO.MetadataClassInfoVO();
          MetadataClasssVO metadataClasssVO = metadataClasssVOS.stream().filter(m -> m.getId().equals(metadataItemVO.getElementClass())).findFirst().orElse(null);
          if (metadataClasssVO == null)
            continue; 
          metadataClassInfoVO.setClassId(String.valueOf(metadataClasssVO.getId()));
          metadataClassInfoVO.setClassCode(metadataClasssVO.getCode());
          metadataClassInfoVO.setClassName(metadataClasssVO.getName());
          metadataClassInfoVO.setOrder(metadataClasssVO.getOrder());
          metadataClassInfoMap.put(metadataClasssVO.getId(), metadataClassInfoVO);
          getEntityBaseInfoVO.getMetadataClassInfoList().add(metadataClassInfoVO);
        } 
        metadataClassInfoVO.getMetadataItemList().add(metadataItemVO);
        metadataClassInfoVO.setMetadataItemList((List)metadataClassInfoVO.getMetadataItemList().stream().filter(metadata -> (metadata.getElementOrder() != null)).sorted(Comparator.comparing(MetadataItemVO::getElementOrder)).collect(Collectors.toList()));
      } 
      getEntityBaseInfoVO.getMetadataClassInfoList().stream().sorted(Comparator.comparing(GetEntityBaseInfoVO.MetadataClassInfoVO::getOrder));
      GetEntityBaseInfoVO.MetadataClassInfoVO base = getEntityBaseInfoVO.getMetadataClassInfoList().stream().filter(f -> f.getClassCode().equals(baseInfo.getCode())).findFirst().orElse(null);
      if (!"Standard".equals(platCode))
        base.getMetadataItemList().addAll(sysThreeField); 
    } 
    getEntityBaseInfoVO.setMetadataClassInfoList((List)getEntityBaseInfoVO.getMetadataClassInfoList().stream().sorted(Comparator.comparing(GetEntityBaseInfoVO.MetadataClassInfoVO::getOrder)).collect(Collectors.toList()));
    QueryModelDTO queryModelDTO = getQueryModelDTOByEntityId(getEntityBaseInfoDTO.getEntityId());
    ResultEntity<List<VersionContentVO>> dataFieldMetadataVersions = this.standardClient.getVersionContentVOList(queryModelDTO, platCode, tokenId);
    if (!CollectionUtils.isEmpty((Collection)dataFieldMetadataVersions.getObj()))
      getEntityBaseInfoVO.setVersionName(((VersionContentVO)((List<VersionContentVO>)dataFieldMetadataVersions.getObj()).get(0)).getVersion()); 
    return ResultEntity.successMessage(getEntityBaseInfoVO);
  }
  
  private QueryModelDTO getQueryModelDTOByEntityId(Long entityId) {
    QueryModelDTO queryModelDTO = new QueryModelDTO();
    FilterModelDTO filterModel = new FilterModelDTO();
    List<FilterGroupModelDTO> filterGroupModel = new ArrayList<>();
    List<FilterFieldDTO> filterFields = new ArrayList<>();
    FilterFieldDTO filterFieldType = new FilterFieldDTO();
    FilterGroupModelDTO filterGroupModelDTO = new FilterGroupModelDTO();
    filterFieldType.setOperationType(DCConst.MetadataInfoValue.EQUIVALENT);
    filterFieldType.setFieldType(DCConst.MetadataInfoValue.FUZZY_QUERY);
    filterFieldType.setFieldName("state");
    filterFieldType.setFieldValue(DCConst.TRUE);
    filterFields.add(filterFieldType);
    FilterFieldDTO filterFieldEntityId = new FilterFieldDTO();
    filterFieldEntityId.setOperationType(DCConst.MetadataInfoValue.EQUIVALENT);
    filterFieldEntityId.setFieldType(DCConst.MetadataInfoValue.FUZZY_QUERY);
    filterFieldEntityId.setFieldName("data_item_id");
    filterFieldEntityId.setFieldValue(entityId);
    filterFields.add(filterFieldEntityId);
    filterGroupModelDTO.setFilterFields(filterFields);
    filterGroupModelDTO.setLogicType(DCConst.FALSE);
    filterGroupModel.add(filterGroupModelDTO);
    filterModel.setFilterGroupModel(filterGroupModel);
    queryModelDTO.setFilterModel(filterModel);
    return queryModelDTO;
  }
  
  public ResultEntity<Boolean> saveEntityBaseInfo(SaveEntityBaseInfoDTO saveEntityBaseInfoDTO, String platCode, String tokenId, Integer dataCategory) {
    List<SaveMetadataItemElementDTO> metadataItemDTOList = saveEntityBaseInfoDTO.getItems();
    if (CollectionUtils.isEmpty(metadataItemDTOList))
      return ResultEntity.errorMessage(Integer.valueOf(-1), "元数据参数为空"); 
    Long directoryId = saveEntityBaseInfoDTO.getDirectoryId();
    Long entityId = saveEntityBaseInfoDTO.getEntityId();
    ResultEntity<Boolean> checkEntityNameAndEntityCode = checkEntityNameAndEntityCode(directoryId, dataCategory, platCode, getEntityName(metadataItemDTOList), saveEntityBaseInfoDTO.getSpecialDatabaseId(), getEntityCode(metadataItemDTOList));
    if (checkEntityNameAndEntityCode.getCode().intValue() != 0)
      return checkEntityNameAndEntityCode; 
    SaveMetadataValueEntityDTO param = new SaveMetadataValueEntityDTO();
    param.setDataCategory(dataCategory);
    param.setItems(saveEntityBaseInfoDTO.getItems());
    param.setEntity(new EntityDefaultPropertyDTO());
    param.getEntity().setDirectoryId(directoryId);
    param.getEntity().setId(entityId);
    param.getEntity().setBusinessId(saveEntityBaseInfoDTO.getBusinessId());
    ResultEntity<MetadataEntityWithElementVO> saveEntityResult = this.standardClient.saveEntity(param, platCode, tokenId);
    if (saveEntityResult.getCode().intValue() != 0)
      return ResultEntity.errorMessage(saveEntityResult.getCode(), saveEntityResult.getMsg()); 
    SaveMetadataEntityDTO saveMetadataEntityDTO = new SaveMetadataEntityDTO();
    saveMetadataEntityDTO.setEntityId(((MetadataEntityWithElementVO)saveEntityResult.getObj()).getId());
    saveMetadataEntityDTO.setDirectoryId(directoryId);
    saveMetadataEntityDTO.setTokenId(tokenId);
    saveMetadataEntityDTO.setPlatCode(platCode);
    saveMetadataEntityDTO.setTableIsSync(saveEntityBaseInfoDTO.getTableIsSync());
    Field[] fields = saveMetadataEntityDTO.getClass().getDeclaredFields();
    for (SaveMetadataItemElementDTO item : metadataItemDTOList) {
      if ("lzdc_sys_database".equals(item.getElementName()) && !StringUtils.isEmpty(item.getElementValue()))
        saveMetadataEntityDTO.setDataSourceId(Long.valueOf(item.getElementValue())); 
      if ("lzdc_sys_physical_table_name".equals(item.getElementName()) && !StringUtils.isEmpty(item.getElementValue()))
        saveMetadataEntityDTO.setEntityTableName(item.getElementValue()); 
      if (item.getElementName().contains("lzdc_sys_expand"))
        try {
          Field curField = Arrays.<Field>stream(fields).filter(f -> item.getElementName().equalsIgnoreCase("lzdc_sys_" + f.getName())).findFirst().orElse(null);
          if (curField != null) {
            curField.setAccessible(true);
            curField.set(saveMetadataEntityDTO, item.getElementValue());
          } 
        } catch (Exception ex) {
          CommonLogHelper.consoleError("反射解析系统内置元数据数据失败", ExceptionUtil.getStackTraceMsg(ex), DCConst.ServerClientType.RESOURCE);
        }  
    } 
    ResultEntity<Boolean> resultEntity = null;
    if (DCConst.DataResourceCategory.RES.equals(dataCategory)) {
      resultEntity = this.iResAndDataResource.saveMetadataEntityForResources(saveMetadataEntityDTO, platCode);
    } else {
      resultEntity = this.iResAndDataResource.saveMetadataEntityForMetadata(saveMetadataEntityDTO, platCode);
    } 
    if (resultEntity.getCode().intValue() != 0)
      return ResultEntity.errorMessage(resultEntity.getCode(), resultEntity.getMsg()); 
    if (DCConst.DataResourceCategory.RES.equals(dataCategory)) {
      ResFileInfoTablePO updateFileInfoTablePO = ((IResourceFileInfoTableDao)ServiceUtil.getResFileInfoTableDao(platCode, IResourceFileInfoTableDao.class)).selectFileInfoTableByDirectotyId(saveMetadataEntityDTO.getDirectoryId());
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(saveMetadataEntityDTO.getEntityId(), dataCategory, platCode, tokenId);
      if (!ObjectUtils.isEmpty(updateFileInfoTablePO) && !ObjectUtils.isEmpty(resAndDataEntityDTO)) {
        UserInfoDTO infoByTokenId = TokenUtil.getUserInfoByTokenId(tokenId);
        if (!ObjectUtils.isEmpty(infoByTokenId)) {
          updateFileInfoTablePO.setUserIdRecord(infoByTokenId.getUserId());
          updateFileInfoTablePO.setOrgIdRecord(infoByTokenId.getOrganizationId());
        } 
        updateFileInfoTablePO.setFileTableCnName(resAndDataEntityDTO.getEntityName() + FILE_SUFFIX);
        updateFileInfoTablePO.setFileTableName(resAndDataEntityDTO.getEntityTableName() + FILE_SUFFIX);
        updateFileInfoTablePO.setFileTableCode(resAndDataEntityDTO.getEntityCode() + FILE_SUFFIX);
        updateFileInfoTablePO.setDataSourceId(saveMetadataEntityDTO.getDataSourceId());
        updateFileInfoTablePO.setUpdateTime(new Date());
        ((IResourceFileInfoTableDao)ServiceUtil.getResFileInfoTableDao(platCode, IResourceFileInfoTableDao.class)).updateFileInfoTableSelective(updateFileInfoTablePO);
      } 
    } 
    return resultEntity;
  }
  
  private String getEntityName(List<SaveMetadataItemElementDTO> metadataItemDTOList) {
    SaveMetadataItemElementDTO saveMetadataItemElementDTO = metadataItemDTOList.stream().filter(s -> "lzdc_sys_entity_name".equals(s.getElementName())).findFirst().orElse(null);
    if (saveMetadataItemElementDTO != null)
      return saveMetadataItemElementDTO.getElementValue(); 
    return null;
  }
  
  private String getEntityCode(List<SaveMetadataItemElementDTO> metadataItemDTOList) {
    SaveMetadataItemElementDTO saveMetadataItemElementDTO = metadataItemDTOList.stream().filter(s -> "lzdc_sys_entity_code".equals(s.getElementName())).findFirst().orElse(null);
    if (saveMetadataItemElementDTO != null)
      return saveMetadataItemElementDTO.getElementValue(); 
    return null;
  }
  
  public void logErrorInfo(String stackInfo, String msg, String platCode, String tokenId) {
    CommonLogDTO logDTO = new CommonLogDTO();
    logDTO.setPlatCode(platCode);
    logDTO.setTokenId(tokenId);
    logDTO.setStackInformation(stackInfo);
    logDTO.setLoggerInformation(msg);
    logDTO.setLogLevel(FrameConst.Log.LOG_LEVEL_ERROR);
    logDTO.setLogType(0);
    logDTO.setModule_code(HeaderInterceptor.getModuleCode());
    RabbitMQUtil.publish("DC.Standard.log", logDTO);
  }
  
  private ResultEntity checkEntityNameAndEntityCode(Long directoryId, Integer dataCategory, String platCode, String directoryName, Long specialDatabaseId, String entityCode) {
    MetadataDirectoryDTO metadataDirectoryDTO = new MetadataDirectoryDTO();
    metadataDirectoryDTO.setDirectoryId(directoryId);
    metadataDirectoryDTO.setDirectoryType(DCConst.MetadataDirectoryType.ITEM_INFO);
    metadataDirectoryDTO.setDataResourceCategory(dataCategory);
    metadataDirectoryDTO.setDirectoryName(directoryName);
    metadataDirectoryDTO.setSpecialDatabaseId(specialDatabaseId);
    metadataDirectoryDTO.setPlatCode(platCode);
    Boolean isExist = (Boolean)((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).checkExistsDirectory(metadataDirectoryDTO).getObj();
    if (!isExist.booleanValue())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ENTITY_NAME_ALREADY_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_ENTITY_NAME_ALREADY_EXISTS.getMessage()); 
    metadataDirectoryDTO.setDirectoryCode(entityCode);
    Boolean codeIsExist = ((IDataResource)ServiceUtil.getDataResourceManager(platCode, IDataResource.class)).checkExistsDirectoryCode(metadataDirectoryDTO);
    if (codeIsExist.booleanValue())
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_ENTITY_CODE_ALREADY_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_ENTITY_CODE_ALREADY_EXISTS.getMessage()); 
    return ResultEntity.successMessage(null);
  }
  
  public ResultEntity<Boolean> updateEntityBaseInfoQuoteTag(UpdateTagMsg updateTagMsg, String platCode, String tokenId) {
    List<TagDTO> tagDTOList = updateTagMsg.getTagDTOList();
    if (!ObjectUtils.isEmpty(tagDTOList))
      for (TagDTO tagDTO : tagDTOList) {
        ResAndDataEntityDTO metadataEntity = MetadataManager.selectEntityByEntityId(tagDTO.getObjId(), DCConst.DataResourceCategory.RES, tagDTO.getPlatCodeEn(), tokenId);
        if (updateTagMsg.getIsDeleteTag().intValue() == 1) {
          metadataEntity.setEntityResTag(null);
        } else {
          metadataEntity.setUpdateTagName(updateTagMsg.getTagName());
          metadataEntity.setTagId(updateTagMsg.getTagId());
        } 
        MetadataManager.saveCommonMetadataEntity(metadataEntity, tagDTO.getPlatCodeEn(), DCConst.DataResourceCategory.RES, tokenId);
      }  
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
}
